/* Stats - IRC Statistical Services for Hybrid, csircd, and IRCnet 2.10
** numeric.h - Server to client numerics and names
**
** Copyright W. Campbell and others.  See README for more details
** Some code Copyright: Jonathan George, Kai Seidler, ircd-hybrid Team,
**                      IRCnet IRCD developers.
**
** $Id: numeric.h,v 1.9 2002/04/02 21:05:21 wcampbel Exp $
*/

#ifndef NUMERIC_H
#define NUMERIC_H

#include "stats.h"

/* Numerics... */
/* All numerics here are Hybrid derived and named the Hybrid way */

#define RPL_TRACEOPERATOR       204
#define RPL_TRACEUSER           205
#define RPL_TRACESERVER         206
#define RPL_STATSCOMMANDS       212
#define RPL_STATSCLINE          213
#define RPL_STATSNLINE          214
#define RPL_STATSILINE          215
/* #define RPL_STATSKLINE               216 - Not supporting now */
#define RPL_STATSYLINE          218
#define RPL_ENDOFSTATS          219
#define RPL_STATSUPTIME         242
#define RPL_STATSOLINE          243
#define RPL_STATSHLINE          244
#define RPL_STATSDEBUG          249
#define RPL_LUSERCLIENT         251
#define RPL_LUSEROP             252
#define RPL_LUSERCHANNELS       254 /* Not yet used */
#define RPL_LUSERME             255
#define RPL_ADMINME             256
#define RPL_ADMINLOC1           257
#define RPL_ADMINLOC2           258
#define RPL_ADMINEMAIL          259
#define RPL_ENDOFTRACE          262
#define RPL_LOCALUSERS          265
#define RPL_GLOBALUSERS         266
#define RPL_WHOISUSER           311
#define RPL_WHOISSERVER         312
#define RPL_WHOISOPERATOR       313
#define RPL_WHOISIDLE           317
#define RPL_ENDOFWHOIS          318
#define RPL_VERSION		351
#define RPL_INFO		371
#define RPL_ENDOFINFO		374
#define RPL_TIME                391

/* These are here but commented out until I can get permission to change
** netgod's SendMOTD function...
**
** #define RPL_MOTD		372
** #define RPL_MOTDSTART	375
** #define RPL_ENDOFMOTD	376
**
*/

#endif
