/* Stats - IRC Statistical Services for Hybrid, csircd, and IRCnet 2.10
** operlist.c - Functions to maintain a linked list of opers
**
** Copyright W. Campbell and others.  See README for more details
** Some code Copyright: Jonathan George, Kai Seidler, ircd-hybrid Team,
**                      IRCnet IRCD developers.
**
** $Id: operlist.c,v 1.2 2002/09/29 03:03:06 wcampbel Exp $
*/

#include "stats.h"
#include "struct.h"
#include "proto.h"

void AddOperToList(dlink_list *operlist, struct User *u)
{
	dlink_node *dl = smalloc(sizeof(dlink_node));
	dlink_add(u, dl, operlist);
}

void DelOperFromList(dlink_list *operlist, struct User *u)
{
	dlink_node *dl = dlink_find(u, operlist);

	if (dl != NULL)
	{
		dlink_delete(dl, operlist);
		free(dl);
		return;
	}
	log("DelOperFromList:  user %s not in list", u->nick);
}

